package com.hfkj.service;

import com.hfkj.entity.SecMenu;
import com.hfkj.model.MenuTreeModel;
import com.hfkj.sysenum.SecMenuTypeEnum;

import java.util.List;
import java.util.Map;

/**
 * @className: SecMenuService
 * @author: HuRui
 * @date: 2024/3/26
 **/
public interface SecMenuService {

    /**
     * 创建
     * @param menu 菜单
     */
    void create(SecMenu menu);

    /**
     * 修改
     * @param menu 菜单
     */
    void update(SecMenu menu);

    /**
     * 删除数据
     * @param menuId
     */
    void delete(Long menuId);

    /**
     * 查询详情
     * @param menuId
     * @return
     */
    SecMenu queryDetail(Long menuId);

    /**
     * 查询菜单列表
     * @param param
     * @return
     */
    List<SecMenu> getList(Map<String,Object> param);

    /**
     * 查询角色菜单
     * @param roleId 角色id
     * @param menuType 菜单类型
     * @return
     */
    List<SecMenu> queryRoleMenu(Long roleId, SecMenuTypeEnum menuType);

    /**
     * 查询菜单列表
     * @return
     */
    List<SecMenu> getAllList();

    /**
     * 分配系统菜单
     * @param roleId 角色id
     * @return
     */
    void assignMenu(Long roleId, List<Long> menuIds);

    /**
     * 查询系统菜单结构
     * @param roleId 角色id
     * @return
     */
    List<MenuTreeModel> queryMenuTree(Long roleId);

}
